Bug 78535 - Source: -ansi used on ANSI C++ incompatible code
Source: -ansi used on ANSI C++ incompatible code
Product: Red Hat Linux
Classification: Retired
Component: redhat-artwork (Show other bugs)
i386 Linux
medium Severity low
: ---
: ---
Assigned To: Havoc Pennington
Depends On:
  Show dependency treegraph
Reported: 2002-11-25 04:57 EST by Sysoltsev Slawa
Modified: 2008-05-01 11:38 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2002-12-13 18:19:05 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Patch which removes -ansi -pedantic from command line (3.89 KB, patch)
2002-11-25 05:09 EST, Sysoltsev Slawa
no flags Details | Diff

  None (edit)
Description Sysoltsev Slawa 2002-11-25 04:57:20 EST
Compiling redhat-artwork on my system with Intel compiler I received such 
during build:

checking for Qt... configure: error: Qt (>= Qt 3.0.3) (library qt-mt) not 
found. Please check your installation!
For more details about this problem, look at the end of config.log.
Make sure that you have compiled Qt with thread support!
error: Bad exit status from /home/users/compiler/tc_5/WORK_DIR/tmp/rpm-
tmp.18404 (%build)

But I have Qt3 installed so I began investigating.
Looking to config.log I realized that configure tried to compile test case 
which uses Qt with '-ansi -pedantic' options. But this is incorrect! Qt library 
uses STL library and gcc3.2 STL library contain GNU extensions: 
see /usr/include/c++/3.2/bits/stl_alloc.h(928) (where actually error is emitted 
with -ansi) and comment above:
  // Inhibit implicit instantiations for required instantiations,
  // which are defined via explicit instantiations elsewhere.
  // NB: This syntax is a GNU extension.

This syntax (I mean 'extern template') isn't described in ANSI C++ specification
(see paragraph 14.7.2 - Explicit instantiation) and therefore isn't allowed 
when -ansi specified in compiler command line.
GNU compiler doesn't STRICT ANSI check so code passes succesfully, but strict 
compiler will emit error. To increase Red Hat Linux portability you shouldn't 
use '-ansi -pedantic' with STL and hence Qt.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. I'm afraid you won't be able to reproduce bug because you haven't compiler I 

Actual Results:  Compilation error.

Expected Results:  Succesfully built package.

Additional info:
I'll attach the patch which removes '-ansi' from command line
Comment 1 Sysoltsev Slawa 2002-11-25 05:09:51 EST
Created attachment 86285 [details]
Patch which removes -ansi -pedantic from command line
Comment 2 Havoc Pennington 2002-12-13 18:19:05 EST
-ansi is only used "if test "$GCC" = "yes""

-ansi would be pretty useless if you couldn't use it together with

If you are convincing configure that gcc is used, you need to use a 
gcc-compatible compiler.

Note You need to log in before you can comment on or make changes to this bug.